//---------------------------------------------------------------------------
// File: C:\cbproj\Remote_CW_Keyer\Keyer_Main.h
// Date: 2023-11-11
// Author: Wolfgang Buescher (DL4YHF)
// Purpose: Main "form" (window) for an experiment to key certain Icom transceivers.
//          Details about the "keying" itself in KeyerThread.c .
//      THIS module is just the BORing graphic user interface,
//      written in a stoneage version of Borland's C++ Builder (BCB V6),
//      using their easy-to-use VCL (Visual Component Library).
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

#ifndef Keyer_MainH
#define Keyer_MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ActnCtrls.hpp>
#include <ActnMan.hpp>
#include <ActnMenus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
class TKeyerMainForm : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
   TMainMenu *MainMenu1;
   TMenuItem *File1;
   TMenuItem *Exit1;
   TPageControl *PageControl1;
   TTabSheet *TS_Config;
   TTabSheet *TS_Debug;
   TTabSheet *TS_Test;
   TTabSheet *TS_KeyerSettings;
   TTabSheet *TS_Audio;
   TTabSheet *TS_TRX;
   TRichEdit *Ed_ErrorHistory;
   TMenuItem *MI_ExitNoSave;
   TTimer *Timer1;
   TMenuItem *Menu_Settings;
   TMenuItem *MI_RestoreDefaultSettings;
   TImage *Img_TimingScopeOnTestTab;
   TImage *Img_TimingScopeOnKeyerTab;
   TTabSheet *TS_Network;
   TTabSheet *TS_Memory;
   TMenuItem *MI_ConnectScopeCh4;
   TMenuItem *N1;
   TMenuItem *MI_Ch4_PTT;
   TMenuItem *MI_Ch4_TestInput;
   TButton *Btn_Mem1;
   TEdit *Ed_Mem1;
   TButton *Btn_Mem2;
   TEdit *Ed_Mem2;
   TButton *Btn_Mem3;
   TEdit *Ed_Mem3;
   TButton *Btn_Mem4;
   TEdit *Ed_Mem4;
   TButton *Btn_Mem5;
   TEdit *Ed_Mem5;
   TButton *Btn_Mem6;
   TEdit *Ed_Mem6;
   TMenuItem *MI_StatusIndicator;
   TMenuItem *MI_SpacerForStatusIndicator;
   TMenuItem *MI_Hotkey_Escape;
   TMenuItem *MI_Hotkeys_F1_to_F6;
   TMenuItem *MI_ColourScheme;
   TMenuItem *MI_ColourScheme_Default;
   TMenuItem *MI_ColourScheme_Dark;
   TMenuItem *MI_ClearScopeOverlays;
   TMenuItem *MI_Help;
   TMenuItem *N2;
   TMenuItem *Hotkeysummary1;
   TMenuItem *MI_HelpIndex;
   TMenuItem *MI_Help_IOConfig;
   TMenuItem *MI_Help_KeyerSettings;
   TMenuItem *MI_Help_TimingScope;
   TMenuItem *MI_Help_Hardware;
   TComboBox *CB_AudioInputDevice;
   TLabel *Label17;
   TLabel *Label18;
   TComboBox *CB_AudioOutputDevice;
   TMenuItem *MI_ClearDebugAndDecoderOutput;
   TMenuItem *MI_Help_AudioSettings;
   TMenuItem *MI_Help_NetworkSettings;
   TLabel *Label19;
   TComboBox *CB_SidetoneOnAudioOut;
   TMenuItem *MI_ReportTestResults;
   TLabel *Label20;
   TLabel *Lab_LocalHost;
   TLabel *Lab_LocalIPHelp;
   TLabel *Lab_LocalIP;
   TLabel *Lab_ServerListeningPort;
   TEdit *Ed_ServerListeningPort;
   TLabel *Lab_NetworkFunctionality;
   TRadioButton *Rbtn_NetworkOff;
   TRadioButton *Rbtn_Client;
   TRadioButton *Rbtn_Server;
   TBevel *Bevel1;
   TLabel *Lab_RemoteURL;
   TEdit *Ed_ClientRemoteIP;
   TLabel *Lab_MyUserName;
   TEdit *Ed_ClientUserName;
   TLabel *Lab_AcceptedUsers;
   TEdit *Ed_ServerAcceptUsers;
   TLabel *Lab_NetStatus;
   TEdit *Ed_NetworkStatus;
   TBevel *Bevel2;
   TMenuItem *MI_NetworkDiagnostics;
   TMenuItem *MI_Network_DiagnosticMode;
   TPopupMenu *PM_ErrorHistory;
   TMenuItem *MI_ClearErrorHistory;
   TMenuItem *MI_Network_ShowRcvdKeyingBytestream;
   TMenuItem *N3;
   TMenuItem *MI_Debug_VerboseDiagnostics;
   TMenuItem *MI_Debug_ShowKeyingBytestream;
   TMenuItem *MI_Debug_PauseDisplay;
   TMenuItem *MI_PauseDebugOutput;
   TMenuItem *MI_CopyHistoryToClipboard;
   TMenuItem *MI_Help_DebugTab;
   TLabel *Lab_Network_OnTheKey;
   TEdit *Ed_OnTheKeyNow;
   TLabel *Lab_UserCallsign;
   TEdit *Ed_ClientCallsign;
   TMenuItem *MI_Debug_ShowMorseDecoderOutput;
   TMenuItem *MI_Settings_ShowMorseDecoderOutput;
   TLabel *Label14;
   TComboBox *CB_SidetoneRiseTime;
   TCheckBox *Chk_Audio_AllowNetwork;
   TScrollBar *SB_SidetoneGain_dB;
   TLabel *Label22;
   TScrollBar *SB_AudioInGain_dB;
   TScrollBar *SB_AudioOutGain_dB;
   TScrollBar *SB_NetworkTonesGain_dB;
   TLabel *Label23;
   TLabel *Label24;
   TLabel *Label25;
   TLabel *Label26;
   TBevel *Bevel_ZerodB;
   TLabel *Label27;
   TMenuItem *MI_ShowAudioWaveforms;
   TMenuItem *MI_TScopeShowAudioIn;
   TMenuItem *MI_TScopeShowAudioOut;
   TPopupMenu *PM_TimingScope;
   TMenuItem *PM_TScope_ShowDashInput;
   TMenuItem *PM_TScope_ShowDotInput;
   TMenuItem *PM_TScope_ShowKeyingOutput;
   TMenuItem *PM_TScope_ShowPttOutput;
   TMenuItem *PM_TScope_ShowAudioIn;
   TMenuItem *PM_TScope_ShowAudioOut;
   TMenuItem *PM_TScope_ClearOverlays;
   TMenuItem *PM_TScope_FreeRun;
   TPanel *TopPanelToFixTheAnchorBug;
   TLabel *Label3;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label6;
   TCheckBox *Chk_MorseKeyDTR;
   TCheckBox *Chk_RadioKeyingDTR;
   TCheckBox *Chk_MorseKeyRTS;
   TCheckBox *Chk_RadioKeyingRTS;
   TStaticText *ST_MorseKeyDCD;
   TStaticText *ST_MorseKeyDSR;
   TStaticText *ST_MorseKeyCTS;
   TStaticText *ST_RadioKeyingDCD;
   TStaticText *ST_RadioKeyingDSR;
   TStaticText *ST_RadioKeyingCTS;
   TCheckBox *Chk_ManualControl;
   TStaticText *ST_MorseKeyRI;
   TStaticText *ST_RadioKeyingRI;
   TPanel *TopPanelToFixTheAnchorBug1;
   TLabel *Label12;
   TLabel *Label13;
   TLabel *Label16;
   TLabel *Label28;
   TLabel *Label29;
   TComboBox *CB_KeyType;
   TTrackBar *TrackBar_WPM;
   TEdit *Ed_WPM;
   TComboBox *CB_SidetoneOnTXD;
   TEdit *Ed_TxHangTime;
   TEdit *Ed_TxDelayTime;
   TButton *Btn_ApplyAndStart;
   TMenuItem *MI_KeyViaShiftAndControl;
   TMenuItem *MI_Network_ShowConnectionLog;
   TMenuItem *N71;
   TMenuItem *MI_Help_About;
   TMenuItem *MI_Network_OpenServerPageInBrowser;
   TCheckBox *Chk_EnableHTTP;
   TLabel *Lab_AdminPWD;
   TEdit *Ed_ServerAdminPWD;
   TMenuItem *MI_NetworkServerOptions;
   TMenuItem *MI_Server_EnableHTTP;
   TMenuItem *MI_Server_RestrictAccess;
   TMenuItem *MI_Server_AddTestTone;
   TMenuItem *MI_Network_SimulateBadConnection;
   TMenuItem *MI_Ch4_NetworkTrouble;
   TMenuItem *MI_Network_ShowNetworkTraffic;
   TMenuItem *MI_Debug_ShowNetworkTraffic;
   TMenuItem *MI_Debug_WordWrap;
   TMenuItem *MI_Debug_ShowNetworkConnectionLog;
   TPanel *Pnl_TRX_Top;
   TEdit *Ed_VFO;
   TPanel *Pnl_TRX_Bottom;
   TComboBox *CB_Mod;
   TMenuItem *MI_Debug_ShowRigCtrlTraffic;
   TMenuItem *MI_Network_ShowRigControlTraffic;
   TMenuItem *MI_Settings_RigControlOptions;
   TMenuItem *MI_RigCtrl_RejectEchosInLog;
   TMenuItem *MI_RigCtrl_RejectPeriodicCmds;
   TMenuItem *MI_RigCtrl_RejectSpectrumInLog;
   TPanel *Pnl_TRX_Center;
   TImage *Img_Spectrum;
   TImage *Img_Waterfall;
   TImage *Img_FreqScale;
   TPopupMenu *PM_TRX_Tab;
   TMenuItem *MI_TRX_Display_Options;
   TMenuItem *MI_TRX_KeepRunning;
   TMenuItem *MI_Settings_TRX_Options;
   TMenuItem *MI_NetworkLatency;
   TMenuItem *MI_NetworkLatency_AutoDetect;
   TMenuItem *MI_NetworkLatency_100ms;
   TMenuItem *MI_NetworkLatency_250ms;
   TMenuItem *MI_NetworkLatency_500ms;
   TMenuItem *MI_NetworkLatency_1000ms;
   TMenuItem *MI_Ch4_KeyingFifoUsage;
   TButton *Btn_StopSendingFromMemory;
   TMenuItem *F12Stoptransmittingfrommemory1;
   TMenuItem *MI_ShowStraightKeyDecoderHistory;
   TMenuItem *MI_MoreKeyerSettings;
   TMenuItem *MI_KeyInputWatchdog;
   TMenuItem *MI_Settings_SpectrumDisplay;
   TMenuItem *MI_SeparatorBelowPauseDebugOutput;
   TMenuItem *MI_Ch4_ElbugKeyerFlags;
   TMenuItem *N6;
   TMenuItem *PM_TScope_Help;
   TButton *Btn_MoreKeyerSettings;
   TMenuItem *MI_DebouncePaddleInputs;
   TPopupMenu *PM_Spectrum;
   TMenuItem *MI_Spectrum_SetVFO;
   TMenuItem *MI_Spectrum_SetTempMarker;
   TMenuItem *MI_Spectrum_SetPermanentMarker;
   TMenuItem *MI_Language;
   TMenuItem *MI_Language_English;
   TMenuItem *MI_Language_German;
   TMenuItem *MI_Language_French;
   TMenuItem *MI_Language_Dutch;
   TMenuItem *MI_Language_Italian;
   TMenuItem *MI_Spectrum_RefLevel;
   TImage *Img_SMeter;
   TPageControl *PC_Config;
   TTabSheet *TS_IO;
   TTabSheet *TS_RigControl;
   TLabel *Label1;
   TComboBox *CB_MorseKeyPort;
   TLabel *Label2;
   TComboBox *CB_RadioKeyingPort;
   TLabel *Label7;
   TComboBox *CB_DotKeyInput;
   TLabel *Label8;
   TComboBox *CB_DashKeyInput;
   TLabel *Label9;
   TComboBox *CB_InputKeySupply;
   TLabel *Label10;
   TComboBox *CB_RadioCWKeying;
   TLabel *Label11;
   TComboBox *CB_RadioPTTControl;
   TLabel *Label15;
   TComboBox *CB_TestInput;
   TLabel *Lab_RigCtrl_CIV_Addr;
   TComboBox *CB_CIV_Address;
   TComboBox *CB_RadioCtrlBaudrate;
   TLabel *Label31;
   TLabel *Lab_RemoteControlMethod;
   TComboBox *CB_RemoteControlMethod;
   TLabel *Lab_RemoteRigControlServer;
   TEdit *Ed_RemoteRigctrlServerAddress;
   TLabel *Label21;
   TEdit *Ed_BuiltInHamlibServerPort;
   TCheckBox *Chk_EnableBuiltInHamlibServer;
   TMenuItem *MI_Help_TransceiverControl;
   TSpeedButton *Btn_Help_HamlibServer;
   TButton *Btn_MoreHLServerOptions;
   TMenuItem *MI_HamlibServerOptions;
   TMenuItem *MI_HLServer_ShowTraffic;
   TMenuItem *MI_HLServer_OpenControlTab;
   TMenuItem *MI_HLServer_Enable;
   TMenuItem *MI_HLServer_VerboseOutput;
   TMenuItem *MI_ReportRigCtrlParams;
   TComboBox *CB_Band;
   TMenuItem *MI_ITU_Region;
   TMenuItem *MI_ITU_Region_1;
   TMenuItem *MI_ITU_Region_2;
   TMenuItem *MI_ITU_Region_3;
   TLabel *Label_ManualPTTInput;
   TComboBox *CB_PTT_Input;
   TButton *Btn_HelpBandSwitch;
   TMenuItem *MI_RigCtrl_RejectFrequencyReports;
   TComboBox *CB_TRX_Bottom;   // <- selects "what to display" in the BOTTOM PANEL on the "TRX"-tab:
   TImage *Img_TRX_Bottom;
   TMenuItem *MI_Functions;
   TMenuItem *MI_Funcs_TRX;
   TMenuItem *MI_Funcs_TrxPowerOn;
   TMenuItem *MI_Funcs_TrxPowerOff;
   TPopupMenu *PM_Waterfall;
   TMenuItem *MI_WFall_SetVFO;
   TMenuItem *MI_Spectrum_Span;
   TMenuItem *MI_SpectrumSpan_2500;
   TMenuItem *MI_SpectrumSpan_5kHz;
   TMenuItem *MI_SpectrumSpan_10kHz;
   TMenuItem *MI_SpectrumSpan_25kHz;
   TMenuItem *MI_SpectrumSpan_50kHz;
   TMenuItem *MI_SpectrumSpan_100kHz;
   TMenuItem *MI_SpectrumSpan_500kHz;
   TMenuItem *MI_SpectrumSpan_250kHz;
   TMenuItem *MI_SeparatorBelowSpectrumDisplaySettings;
   TMenuItem *MI_Help_MainMenu;
   TMenuItem *MI_Settings_UserInterface;
   TMenuItem *MI_UI_Simple;
   TMenuItem *MI_UI_Complete;
   void __fastcall Exit1Click(TObject *Sender);
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall MI_ExitNoSaveClick(TObject *Sender);
   void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall ApplyManualTestSignals(TObject *Sender);
   void __fastcall MI_RestoreDefaultSettingsClick(TObject *Sender);
   void __fastcall ApplyKeyerSettings(TObject *Sender);
   void __fastcall TrackBar_WPMChange(TObject *Sender);
   void __fastcall Ed_WPMChange(TObject *Sender);
   void __fastcall Menu_SettingsClick(TObject *Sender);
   void __fastcall MI_Ch4_PTTClick(TObject *Sender);
   void __fastcall MI_Ch4_TestInputClick(TObject *Sender);
   void __fastcall Btn_Mem1Click(TObject *Sender);
   void __fastcall Btn_Mem2Click(TObject *Sender);
   void __fastcall Btn_Mem3Click(TObject *Sender);
   void __fastcall Btn_Mem4Click(TObject *Sender);
   void __fastcall Btn_Mem5Click(TObject *Sender);
   void __fastcall Btn_Mem6Click(TObject *Sender);
   void __fastcall Ed_MemChange(TObject *Sender);
   void __fastcall MI_Hotkey_EscapeClick(TObject *Sender);
   void __fastcall MI_StatusIndicatorClick(TObject *Sender);
   void __fastcall MI_ColourScheme_DefaultClick(TObject *Sender);
   void __fastcall MI_ColourScheme_DarkClick(TObject *Sender);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall Img_TimingScopeOnTestTabMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_TimingScopeOnTestTabMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall Img_TimingScopeOnTestTabMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_TimingScopeOnKeyerTabMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_TimingScopeOnKeyerTabMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall Img_TimingScopeOnKeyerTabMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall MI_ClearScopeOverlaysClick(TObject *Sender);
   void __fastcall Hotkeysummary1Click(TObject *Sender);
   void __fastcall MI_HelpIndexClick(TObject *Sender);
   void __fastcall MI_Help_IOConfigClick(TObject *Sender);
   void __fastcall MI_Help_KeyerSettingsClick(TObject *Sender);
   void __fastcall MI_Help_TimingScopeClick(TObject *Sender);
   void __fastcall MI_Help_HardwareClick(TObject *Sender);
   void __fastcall MI_ClearDebugAndDecoderOutputClick(TObject *Sender);
   void __fastcall MI_Help_AudioSettingsClick(TObject *Sender);
   void __fastcall MI_Help_NetworkSettingsClick(TObject *Sender);
   void __fastcall MI_ReportTestResultsClick(TObject *Sender);
   void __fastcall ApplyNetworkSetup(TObject *Sender);
   void __fastcall MI_Network_DiagnosticModeClick(TObject *Sender);
   void __fastcall CB_SidetoneOnAudioOutChange(TObject *Sender);
   void __fastcall Lab_NetworkFunctionalityClick(TObject *Sender);
   void __fastcall Lab_NetStatusClick(TObject *Sender);
   void __fastcall Lab_AcceptedUsersClick(TObject *Sender);
   void __fastcall MI_ClearErrorHistoryClick(
          TObject *Sender);
   void __fastcall MI_Network_ShowRcvdKeyingBytestreamClick(
          TObject *Sender);
   void __fastcall MI_Debug_ShowKeyingBytestreamClick(TObject *Sender);
   void __fastcall MI_Debug_VerboseDiagnosticsClick(TObject *Sender);
   void __fastcall MI_Debug_PauseDisplayClick(TObject *Sender);
   void __fastcall PM_ErrorHistoryPopup(TObject *Sender);
   void __fastcall MI_PauseDebugOutputClick(TObject *Sender);
   void __fastcall MI_CopyHistoryToClipboardClick(TObject *Sender);
   void __fastcall MI_Help_DebugTabClick(TObject *Sender);
   void __fastcall MI_Debug_ShowMorseDecoderOutputClick(TObject *Sender);
   void __fastcall MI_Settings_ShowMorseDecoderOutputClick(
          TObject *Sender);
   void __fastcall Ed_ServerAcceptUsersDblClick(TObject *Sender);
   void __fastcall MyDrawMenuItem(TObject *Sender, TCanvas *ACanvas,
          TRect &ARect, bool Selected);
   void __fastcall DrawStatusIndicatorInMenu(TObject *Sender,
          TCanvas *ACanvas, TRect &ARect, bool Selected);
   void __fastcall Chk_Audio_AllowNetworkClick(TObject *Sender);
   void __fastcall ApplyVolumeAdjustments(TObject *Sender);
   void __fastcall MI_TScopeShowAudioInClick(TObject *Sender);
   void __fastcall MI_TScopeShowAudioOutClick(TObject *Sender);
   void __fastcall PM_TimingScopePopup(TObject *Sender);
   void __fastcall PM_TScope_ShowAudioInClick(TObject *Sender);
   void __fastcall PM_TScope_ShowAudioOutClick(TObject *Sender);
   void __fastcall PM_TScope_ClearOverlaysClick(TObject *Sender);
   void __fastcall PM_TScope_ShowDashInputClick(TObject *Sender);
   void __fastcall PM_TScope_ShowDotInputClick(TObject *Sender);
   void __fastcall PM_TScope_ShowKeyingOutputClick(TObject *Sender);
   void __fastcall PM_TScope_ShowPttOutputClick(TObject *Sender);
   void __fastcall PM_TScope_FreeRunClick(TObject *Sender);
   void __fastcall Btn_ApplyAndStartClick(TObject *Sender);
   void __fastcall MI_KeyViaShiftAndControlClick(TObject *Sender);
   void __fastcall MI_Network_ShowConnectionLogClick(TObject *Sender);
   void __fastcall MI_Help_AboutClick(TObject *Sender);
   void __fastcall MI_Network_OpenServerPageInBrowserClick(
          TObject *Sender);
   void __fastcall MI_Server_EnableHTTPClick(TObject *Sender);
   void __fastcall MI_Server_RestrictAccessClick(TObject *Sender);
   void __fastcall MI_Server_AddTestToneClick(TObject *Sender);
   void __fastcall MI_Network_SimulateBadConnectionClick(TObject *Sender);
   void __fastcall MI_Ch4_NetworkTroubleClick(TObject *Sender);
   void __fastcall MI_Network_ShowNetworkTrafficClick(TObject *Sender);
   void __fastcall MI_Debug_ShowNetworkTrafficClick(TObject *Sender);
   void __fastcall MI_Debug_ToggleWordWrap(TObject *Sender);
   void __fastcall MI_Debug_ShowNetworkConnectionLogClick(TObject *Sender);
   void __fastcall EditSuppressEnterKey(TObject *Sender, char &Key);
   void __fastcall Ed_VFOKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
   void __fastcall Ed_VFOChange(TObject *Sender);
   void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
   void __fastcall CB_ModClick(TObject *Sender);
   void __fastcall MI_Debug_ShowRigCtrlTrafficClick(TObject *Sender);
   void __fastcall MI_Network_ShowRigControlTrafficClick(TObject *Sender);
   void __fastcall MI_RigCtrl_RejectEchosInLogClick(TObject *Sender);
   void __fastcall MI_RigCtrl_RejectPeriodicCmdsClick(TObject *Sender);
   void __fastcall MI_RigCtrl_RejectSpectrumInLogClick(TObject *Sender);
   void __fastcall Lab_LocalIPHelpClick(TObject *Sender);
   void __fastcall Lab_ServerListeningPortClick(TObject *Sender);
   void __fastcall Lab_RemoteURLClick(TObject *Sender);
   void __fastcall Lab_MyUserNameClick(TObject *Sender);
   void __fastcall Lab_UserCallsignClick(TObject *Sender);
   void __fastcall PM_TRX_TabPopup(TObject *Sender);
   void __fastcall MI_TRX_KeepRunningClick(TObject *Sender);
   void __fastcall MI_Settings_TRX_OptionsClick(TObject *Sender);
   void __fastcall MI_NetworkLatency_AutoDetectClick(TObject *Sender);
   void __fastcall MI_NetworkLatency_100msClick(TObject *Sender);
   void __fastcall MI_NetworkLatency_250msClick(TObject *Sender);
   void __fastcall MI_NetworkLatency_500msClick(TObject *Sender);
   void __fastcall MI_NetworkLatency_1000msClick(TObject *Sender);
   void __fastcall MI_Ch4_KeyingFifoUsageClick(TObject *Sender);
   void __fastcall Btn_StopSendingFromMemoryClick(TObject *Sender);
   void __fastcall MI_ShowStraightKeyDecoderHistoryClick(TObject *Sender);
   void __fastcall MI_KeyInputWatchdogClick(TObject *Sender);
   void __fastcall Img_SpectrumMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_SpectrumMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall Img_SpectrumMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall MI_Ch4_ElbugKeyerFlagsClick(TObject *Sender);
   void __fastcall PM_TScope_HelpClick(TObject *Sender);
   void __fastcall Btn_MoreKeyerSettingsClick(TObject *Sender);
   void __fastcall MI_DebouncePaddleInputsClick(TObject *Sender);
   void __fastcall PM_SpectrumPopup(TObject *Sender);
   void __fastcall MI_Spectrum_SetVFOClick(TObject *Sender);
   void __fastcall MI_Spectrum_SetPermanentMarkerClick(TObject *Sender);
   void __fastcall MI_Language_EnglishClick(TObject *Sender);
   void __fastcall MI_Language_GermanClick(TObject *Sender);
   void __fastcall MI_Language_FrenchClick(TObject *Sender);
   void __fastcall MI_Language_DutchClick(TObject *Sender);
   void __fastcall MI_Language_ItalianClick(TObject *Sender);
   void __fastcall MI_Spectrum_RefLevelClick(TObject *Sender);
   void __fastcall CB_RemoteControlMethodClick(TObject *Sender);
   void __fastcall MI_Help_TransceiverControlClick(TObject *Sender);
   void __fastcall Btn_Help_HamlibServerClick(TObject *Sender);
   void __fastcall Btn_MoreHLServerOptionsClick(TObject *Sender);
   void __fastcall MI_HLServer_OpenControlTabClick(TObject *Sender);
   void __fastcall MI_HLServer_EnableClick(TObject *Sender);
   void __fastcall MI_HLServer_ShowTrafficClick(TObject *Sender);
   void __fastcall MI_HLServer_VerboseOutputClick(TObject *Sender);
   void __fastcall MI_ReportRigCtrlParamsClick(TObject *Sender);
   void __fastcall CB_BandClick(TObject *Sender);
   void __fastcall MI_ITU_Region_1Click(TObject *Sender);
   void __fastcall MI_ITU_Region_2Click(TObject *Sender);
   void __fastcall MI_ITU_Region_3Click(TObject *Sender);
   void __fastcall Btn_HelpBandSwitchClick(TObject *Sender);
   void __fastcall PageControl1Change(TObject *Sender);
   void __fastcall MI_RigCtrl_RejectFrequencyReportsClick(TObject *Sender);
   void __fastcall MI_Funcs_TrxPowerOffClick(TObject *Sender);
   void __fastcall MI_Funcs_TrxPowerOnClick(TObject *Sender);
   void __fastcall MI_WFall_SetVFOClick(TObject *Sender);
   void __fastcall Img_WaterfallMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_WaterfallMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall Img_WaterfallMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall PM_WaterfallPopup(TObject *Sender);
   void __fastcall MI_SpectrumSpan_500kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_2500Click(TObject *Sender);
   void __fastcall MI_SpectrumSpan_5kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_10kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_25kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_50kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_100kHzClick(TObject *Sender);
   void __fastcall MI_SpectrumSpan_250kHzClick(TObject *Sender);
   void __fastcall MI_Settings_SpectrumDisplayClick(TObject *Sender);
   void __fastcall MI_Help_MainMenuClick(TObject *Sender);
   void __fastcall MI_UI_SimpleClick(TObject *Sender);
   void __fastcall MI_UI_CompleteClick(TObject *Sender);
   void __fastcall MI_HelpClick(TObject *Sender);
private:	// Anwender-Deklarationen
public:		// Anwender-Deklarationen
   __fastcall TKeyerMainForm(TComponent* Owner);
   void __fastcall AppMessage(tagMSG &Msg, bool &Handled);

   // BOOL OnNonClientPaint( HWND hWnd, HRGN hRegion );
   void OnNonClientPaint( HRGN hUpdateRegion );
   void SetNewLanguage( int iNewLanguage );
   void UpdateWindowCaption(void);
   
   void UpdateTrxDisplay(void);
   void UpdateMultiFunctionMeters(void); // [out] Img_TRX_Bottom (part of the "TRX" tab)

   void UpdateSettingsTab(void);
   void UpdateRigControlMethodDependingFields(void);

   void ApplySettingsTab(void);
   void ApplyAndStart(void);
   void ApplyNewVFOFreq(void); // Ed_VFO -> MyCwNet.RigControl.dblVfoFrequency
   void StartVFOEditTimer(int nMilliseconds);
   void UpdateVFODisplay( double dblVfoFrequency_Hz ); // -> Ed_VFO
   void AddAudioInputDevice( AnsiString sItemText );
   void AddAudioOutputDevice( AnsiString sItemText );
   void UpdateAudioDeviceCombos(void);
   void UpdateTestDisplay(void);
   void UpdateItemsInSettingsMenu(void);
   BOOL DumpErrorHistoryToDebugTab(void);   // ErrorHistoryFifo[] (circular FIFO) -> Ed_ErrorHistory (Rich Text control)
   BOOL DumpRigCtrlTrafficToDebugTab(int iWantedCharsPerLine); // TrafficLog[] -> Ed_ErrorHistory (Rich Text control)
   void UpdateStatusIndicatorText(void); // -> m_sz80StatusIndicatorText
   void UpdateStatusIndicator(void);
   void UpdateNetworkSetup(void);
   void UpdateClientServerLabels(void);
   void AdaptImageSizesOnTRXTab(void);
   void StartKeyerAndShowInfo(void);
   void StartPlaying( int iMemoryIndex );
   void PauseTransmission(void);
   TEdit* GetEditorForMemoryIndex( int iMemoryIndex );
   int  IdentifyClientCoord( int iClientX, int iClientY,
         float *pfltXrel,  // optional output: relative 'X' coord, 0...1 within the area
         float *pfltYrel); // optional output: relative 'X' coord, 0...1 within the area
#   define SCREEN_AREA_NOT_DEFINED      0
#   define SCREEN_AREA_SPECTRUM_GRAPH   1
#   define SCREEN_AREA_FREQUENCY_SCALE  2
#   define SCREEN_AREA_SPECTROGRAM      3
   void SwitchMainTab(int iNewTab); // [in] one of the following:
#   define MAIN_TAB_UNKNOWN        0 // <- only a dummy for m_iCurrentMainTab
#   define MAIN_TAB_CONFIG         1
#   define MAIN_TAB_KEYER_SETTINGS 2
#   define MAIN_TAB_AUDIO          3
#   define MAIN_TAB_NETWORK        4
#   define MAIN_TAB_DEBUG          5
#   define MAIN_TAB_MEMORY         6
#   define MAIN_TAB_TEST           7 // "Test" tab with the 'CW timing' scope
#   define MAIN_TAB_TRX            8
   int   m_iCurrentMainTab; // also contains one of the MAIN_TAB_.. constants, set via SwitchMainTab()
   BOOL  m_fAutomaticTabSwitching; // normally FALSE = "tabs switched by the USER";  TRUE to allow e.g. switching from MAIN_TAB_DEBUG to MAIN_TAB_TRX when the 'rig initialisation' is finished.
   BOOL  m_fInitialising, m_fRestartKeyerThread, m_fAdaptImageSizesOnTRXTab;
   BOOL  m_fDontSaveOnExit;
   DWORD m_dwHashForSettings;  // hash value calculated for 'anything that needs to be saved' between two sessions
   int  m_iUpdating;
   int  m_iDecoderFifoTail;
   int  m_iCurrentMemoryIndex; // zero-based MESSAGE INDEX while playing CW from memory
   int  m_iCurrentCharIndex;   // zero-based CHARACTER INDEX, used for highlighting
        // the currently played position (e.g. in edit field #m_iCurrentMemoryIndex)
   int  m_iStatusIndicatorUsage; // one of the following (some bitwise combineable):
#       define STATUS_INDICATOR_OFF    0  // Keyer Thread not started yet
#       define STATUS_INDICATOR_IDLE   1  // not transmitting yet
#       define STATUS_INDICATOR_ON_AIR 2  // "on air" (PTT active, or at least "sending Morse")
#       define STATUS_INDICATOR_TX_MEM 4  // sending CW from one of the "TX memories"
#       define STATUS_INDICATOR_CW_TEST 8 // "generating" CW but not TRANSMITTING (with manual PTT control, but PTT currently off)
#       define STATUS_INDICATOR_PAUSED 16 // operator pressed the "panic" button (ESCAPE)
   char m_sz80StatusIndicatorText[84];
   char m_sz80LastMarkerText[84];
   int  m_iTransmittingClient;    // copy of T_CwNet.iTransmittingClient for the "On the key now"-display
   int  m_iStatusIndicatorMemIdx; // last value of m_iCurrentMemoryIndex shown in the 'status indicator'
   BOOL m_fDebugOutputPaused;
   int  m_iMorseFIFOTailIndex2;   // only for debugging / CWNET_DIAG_FLAGS_SHOW_KEYING_BYTESTREAM
   int  m_iDisplayedRigControlOpMode;
   DWORD m_dwDisplayedSelectedBand, m_dwDisplayedAvailableBands;
   double m_dblDisplayedSMeterLevel_dB;
   double m_dblDisplayedSWRMeterValue;
   int    m_iDisplayedPowerMeterLevel_pcnt;
   int  m_iDisplayedALCMeterLevel_pcnt;
   int  m_iDisplayedCompMeterLevel_dB;
   int  m_iDisplayedSupplyVoltage_mV;
   int  m_iDisplayedDrainCurrent_mA;
   int  m_iDisplayediPATemperature_degC;

   int  m_iRigControlTrafficTailIndex, m_iPrevMsgTypeInTrafficLog;
   int  m_iLastScopeDisplayHeadIndex; // keeps track of 'new' spectra ("waveform data") in RigControl.c
   int  m_iMouseButtonAsGuiKeyFlags;

   // Item indices for CB_TRX_Bottom (combo box to control what's displayed in the lower part of the "TRX" tab) :
#       define CB_TRX_BOTTOM_SHOW_MULTI_FUNCTION_METER 0  // S-Meter/Power, ALC, Compressor, SWR, Drain current, Supply Voltage, PA Temperature

};
//---------------------------------------------------------------------------
extern PACKAGE TKeyerMainForm *KeyerMainForm;
//---------------------------------------------------------------------------
#endif
